diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/lte/test/lte-test-ue-measurements.cc ns-3.32/src/lte/test/lte-test-ue-measurements.cc
--- ns-3.31/src/lte/test/lte-test-ue-measurements.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/lte/test/lte-test-ue-measurements.cc	2020-10-06 15:35:43.000000000 -0700
@@ -1357,6 +1357,253 @@
 }
 
 
+// ===== LTE-UE-MEASUREMENTS-PIECEWISE-3 TEST SUITE ======================== //
+
+/*
+ * Test Suite
+ */
+
+LteUeMeasurementsPiecewiseTestSuite3::LteUeMeasurementsPiecewiseTestSuite3 ()
+  : TestSuite ("lte-ue-measurements-piecewise-3", SYSTEM)
+{
+  std::vector<Time> expectedTime;
+
+  // === Event A4 (neighbor becomes better than threshold) ===
+
+  //The threshold value was chosen to achieve the following:
+  //1. Neighbor 1 (eNB2) RSRP would be above the chosen threshold, hence,
+  //the UE will include it in its reports to its eNB (eNB1) from the beginning
+  //of the simulation.
+  //2. When neighbor 2 (eNB3) is placed at a very far position, its RSRP would
+  //be less than the chosen threshold, hence, UE will not include it in its
+  //initial report(s) to its eNB.
+  //3. When neighbor 2 (eNB3) is placed at a near position, its RSRP would
+  //always be above the chosen threshold, hence, the UE will include it in its
+  //reports to its eNB (eNB1).
+  LteRrcSap::ReportConfigEutra config;
+  config.triggerType = LteRrcSap::ReportConfigEutra::EVENT;
+  config.eventId = LteRrcSap::ReportConfigEutra::EVENT_A4;
+  config.threshold1.choice = LteRrcSap::ThresholdEutra::THRESHOLD_RSRP;
+  config.threshold1.range = 6;
+  config.triggerQuantity = LteRrcSap::ReportConfigEutra::RSRP;
+  config.reportInterval = LteRrcSap::ReportConfigEutra::MS240;
+  expectedTime.clear ();
+  expectedTime << 200 << 440 << 680 << 920 << 1160 << 1400 << 1640 << 1880 << 2120;
+
+  AddTestCase (new LteUeMeasurementsPiecewiseTestCase3 ("Piecewise test case 3 - Event A4",
+                                                        config, expectedTime),TestCase::QUICK);
+} // end of LteUeMeasurementsPiecewiseTestSuite3::LteUeMeasurementsPiecewiseTestSuite3
+
+static LteUeMeasurementsPiecewiseTestSuite3 lteUeMeasurementsPiecewiseTestSuite3;
+
+
+/*
+ * Test Case
+ */
+
+LteUeMeasurementsPiecewiseTestCase3::LteUeMeasurementsPiecewiseTestCase3 (
+  std::string name, LteRrcSap::ReportConfigEutra config,
+  std::vector<Time> expectedTime)
+  : TestCase (name),
+    m_config (config),
+    m_expectedTime (expectedTime)
+{
+  m_expectedMeasId = std::numeric_limits<uint8_t>::max ();
+
+  m_itExpectedTime = m_expectedTime.begin ();
+
+  NS_LOG_INFO (this << " name=" << name);
+}
+
+LteUeMeasurementsPiecewiseTestCase3::~LteUeMeasurementsPiecewiseTestCase3 ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+void
+LteUeMeasurementsPiecewiseTestCase3::DoRun ()
+{
+  NS_LOG_INFO (this << " " << GetName ());
+
+  Ptr<LteHelper> lteHelper = CreateObject<LteHelper> ();
+  lteHelper->SetAttribute ("PathlossModel",
+                           StringValue ("ns3::FriisSpectrumPropagationLossModel"));
+  lteHelper->SetAttribute ("UseIdealRrc", BooleanValue (true));
+
+  //Disable Uplink Power Control
+  Config::SetDefault ("ns3::LteUePhy::EnableUplinkPowerControl", BooleanValue (false));
+
+  // Create Nodes: eNodeB and UE
+  NodeContainer enbNodes;
+  NodeContainer ueNodes;
+  enbNodes.Create (3);
+  ueNodes.Create (1);
+
+  /*
+   * The topology is the following:
+   *
+   * We place the 3rd eNB initially very far so it does not fulfills
+   * the entry condition to be reported.
+   *
+   * eNodeB    UE              eNodeB                                  eNodeB
+   *    |      |                 |                                       |
+   *    x ---- x --------------- x -------------- x ---------------------x
+   *      50 m         100 m             500      |         1000000
+   *                                             Near
+   */
+
+  Ptr<ListPositionAllocator> positionAlloc = CreateObject<ListPositionAllocator> ();
+  positionAlloc->Add (Vector (0.0, 0.0, 0.0)); // Serving eNodeB
+  positionAlloc->Add (Vector (200.0, 0.0, 0.0)); // Neighbour eNodeB1
+  positionAlloc->Add (Vector (1000700.0, 0.0, 0.0)); // Neighbour eNodeB2
+  positionAlloc->Add (Vector (50.0, 0.0, 0.0)); // UE
+  MobilityHelper mobility;
+  mobility.SetMobilityModel ("ns3::ConstantPositionMobilityModel");
+  mobility.SetPositionAllocator (positionAlloc);
+  mobility.Install (enbNodes);
+  mobility.Install (ueNodes);
+  m_enbMobility = enbNodes.Get (2)->GetObject<MobilityModel> ();
+
+  // Disable layer-3 filtering
+  Config::SetDefault ("ns3::LteEnbRrc::RsrpFilterCoefficient",
+                      UintegerValue (0));
+
+  // Create Devices and install them in the Nodes (eNB and UE)
+  NetDeviceContainer enbDevs;
+  NetDeviceContainer ueDevs;
+  lteHelper->SetSchedulerType ("ns3::RrFfMacScheduler");
+  lteHelper->SetSchedulerAttribute ("UlCqiFilter",
+                                    EnumValue (FfMacScheduler::PUSCH_UL_CQI));
+  enbDevs = lteHelper->InstallEnbDevice (enbNodes);
+  ueDevs = lteHelper->InstallUeDevice (ueNodes);
+
+  // Setup UE measurement configuration in serving cell
+  Ptr<LteEnbRrc> enbRrc1 = enbDevs.Get (0)->GetObject<LteEnbNetDevice> ()->GetRrc ();
+  m_expectedMeasId = enbRrc1->AddUeMeasReportConfig (m_config);
+
+  // Disable handover in neighbour cells
+  Ptr<LteEnbRrc> enbRrc2 = enbDevs.Get (1)->GetObject<LteEnbNetDevice> ()->GetRrc ();
+  enbRrc2->SetAttribute ("AdmitHandoverRequest", BooleanValue (false));
+  Ptr<LteEnbRrc> enbRrc3 = enbDevs.Get (2)->GetObject<LteEnbNetDevice> ()->GetRrc ();
+  enbRrc3->SetAttribute ("AdmitHandoverRequest", BooleanValue (false));
+
+  // Attach UE to serving eNodeB
+  lteHelper->Attach (ueDevs.Get (0), enbDevs.Get (0));
+
+  // Activate an EPS bearer
+  enum EpsBearer::Qci q = EpsBearer::GBR_CONV_VOICE;
+  EpsBearer bearer (q);
+  lteHelper->ActivateDataRadioBearer (ueDevs, bearer);
+
+  // Connect to trace sources in serving eNodeB
+  Config::Connect ("/NodeList/0/DeviceList/0/LteEnbRrc/RecvMeasurementReport",
+                   MakeCallback (&LteUeMeasurementsPiecewiseTestCase3::RecvMeasurementReportCallback,
+                                 this));
+  /*
+   * Schedule "teleport" for the 2nd neighbour
+   *
+   * We bring the 2nd neighbour near once the UE has already scheduled the periodic
+   * reporting after detecting the 1st neighbour, which ideally should be at
+   * 200 ms.
+   */
+  Simulator::Schedule (MilliSeconds (301),
+                       &LteUeMeasurementsPiecewiseTestCase3::TeleportEnbNear, this);
+
+  // Run simulation
+  Simulator::Stop (Seconds (2.201));
+  Simulator::Run ();
+  Simulator::Destroy ();
+
+} // end of void LteUeMeasurementsPiecewiseTestCase3::DoRun ()
+
+void
+LteUeMeasurementsPiecewiseTestCase3::DoTeardown ()
+{
+  NS_LOG_FUNCTION (this);
+  bool hasEnded = m_itExpectedTime == m_expectedTime.end ();
+  NS_TEST_ASSERT_MSG_EQ (hasEnded, true,
+                         "Reporting should have occurred at " << m_itExpectedTime->GetSeconds () << "s");
+}
+
+void
+LteUeMeasurementsPiecewiseTestCase3::RecvMeasurementReportCallback (
+  std::string context, uint64_t imsi, uint16_t cellId, uint16_t rnti,
+  LteRrcSap::MeasurementReport report)
+{
+  NS_LOG_FUNCTION (this << context);
+  NS_ASSERT (rnti == 1);
+  NS_ASSERT (cellId == 1);
+
+  if (report.measResults.measId == m_expectedMeasId)
+    {
+      // verifying the report completeness
+      LteRrcSap::MeasResults measResults = report.measResults;
+      NS_LOG_DEBUG (this << " Serving cellId=" << cellId
+                         << " rsrp=" << (uint16_t) measResults.rsrpResult
+                         << " (" << EutranMeasurementMapping::RsrpRange2Dbm (measResults.rsrpResult) << " dBm)"
+                         << " rsrq=" << (uint16_t) measResults.rsrqResult
+                         << " (" << EutranMeasurementMapping::RsrqRange2Db (measResults.rsrqResult) << " dB)");
+
+      // verifying reported best cells
+      if (measResults.measResultListEutra.size () == 0)
+        {
+          NS_TEST_ASSERT_MSG_EQ (measResults.haveMeasResultNeighCells, false,
+                                 "Unexpected report content");
+        }
+      else
+        {
+          NS_TEST_ASSERT_MSG_EQ (measResults.haveMeasResultNeighCells, true,
+                                 "Unexpected report content");
+          std::list<LteRrcSap::MeasResultEutra>::iterator it = measResults.measResultListEutra.begin ();
+          NS_ASSERT (it != measResults.measResultListEutra.end ());
+          for (const auto &it:measResults.measResultListEutra)
+            {
+              NS_ASSERT (it.physCellId == 2 || it.physCellId == 3);
+              NS_TEST_ASSERT_MSG_EQ (it.haveCgiInfo, false,
+                                     "Report contains cgi-info, which is not supported");
+              NS_TEST_ASSERT_MSG_EQ (it.haveRsrpResult, true,
+                                     "Report does not contain measured RSRP result");
+              NS_TEST_ASSERT_MSG_EQ (it.haveRsrqResult, true,
+                                     "Report does not contain measured RSRQ result");
+              NS_LOG_DEBUG (this << " Neighbour cellId=" << it.physCellId
+                            << " rsrp=" << (uint16_t) it.rsrpResult
+                            << " (" << EutranMeasurementMapping::RsrpRange2Dbm (it.rsrpResult) << " dBm)"
+                            << " rsrq=" << (uint16_t) it.rsrqResult
+                            << " (" << EutranMeasurementMapping::RsrqRange2Db (it.rsrqResult) << " dB)");
+            }
+
+        } // end of else of if (measResults.measResultListEutra.size () == 0)
+
+      // verifying the report timing
+      bool hasEnded = m_itExpectedTime == m_expectedTime.end ();
+      NS_TEST_ASSERT_MSG_EQ (hasEnded, false,
+                             "Reporting should not have occurred at "
+                             << Simulator::Now ().GetSeconds () << "s");
+      if (!hasEnded)
+        {
+          // using milliseconds to avoid floating-point comparison
+          uint64_t timeNowMs = Simulator::Now ().GetMilliSeconds ();
+          uint64_t timeExpectedMs = m_itExpectedTime->GetMilliSeconds ();
+          m_itExpectedTime++;
+
+
+          NS_TEST_ASSERT_MSG_EQ (timeNowMs, timeExpectedMs,
+                                 "Reporting should not have occurred at this time");
+
+        } // end of if (!hasEnded)
+
+    } // end of if (report.measResults.measId == m_expectedMeasId)
+
+} // end of void LteUeMeasurementsPiecewiseTestCase3::RecvMeasurementReportCallback
+
+void
+LteUeMeasurementsPiecewiseTestCase3::TeleportEnbNear ()
+{
+  NS_LOG_FUNCTION (this);
+  m_enbMobility->SetPosition (Vector (700.0, 0.0, 0.0));
+}
+
+
 // ===== LTE-UE-MEASUREMENTS-HANDOVER TEST SUITE =========================== //
 
 /*
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/lte/test/lte-test-ue-measurements.h ns-3.32/src/lte/test/lte-test-ue-measurements.h
--- ns-3.31/src/lte/test/lte-test-ue-measurements.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/lte/test/lte-test-ue-measurements.h	2020-10-06 15:35:43.000000000 -0700
@@ -392,6 +392,143 @@
 
 }; // end of class LteUeMeasurementsPiecewiseTestCase2
 
+// ===== LTE-UE-MEASUREMENTS-PIECEWISE-3 TEST SUITE ======================== //
+
+
+/**
+ * \ingroup lte-test
+ * \ingroup tests
+ *
+ * \brief Test suite for generating calls to UE measurements test case
+ *        ns3::LteUeMeasurementsPiecewiseTestCase3.
+ */
+class LteUeMeasurementsPiecewiseTestSuite3 : public TestSuite
+{
+public:
+  LteUeMeasurementsPiecewiseTestSuite3 ();
+};
+
+
+/**
+ * \ingroup lte-test
+ * \ingroup tests
+ *
+ * \brief Testing UE measurements in LTE with simulation of 3 eNodeB and 1 UE in
+ *        piecewise configuration and 240 ms report interval.
+ *        This test is to cover a corner case using event A4, which is not
+ *        covered by LteUeMeasurementsPiecewiseTestCase1 and
+ *        LteUeMeasurementsPiecewiseTestCase2. In this case, we test that the UE
+ *        measurements at eNB are arriving 240 ms apart. Please note, the
+ *        scenario simulated is engineered to specifically test the corner case
+ *        in which whenever a new neighbour fulfils the entry condition
+ *        for event A4, the UE RRC calls VarMeasReportListAdd method to include
+ *        the new cell id in cellsTriggeredList, and then it schedules the
+ *        SendMeasurementReport for periodic reporting. However, if the UE has
+ *        already started the periodic reporting, scheduling the
+ *        SendMeasurementReport method again causes following buggy behaviors:
+ *
+ *        1. It generates an intermediate measurement event, which then leads
+ *        to parallel intermediate measurement reports from a UE to its eNB.
+ *
+ *        2. The old EvenId is overwritten by the new EventId stored in
+ *        VarMeasReportList. This makes us lose control over the old EventId
+ *        and it is impossible to cancel its events later on.
+ *
+ *        These buggy behaviors generated an issue reported in
+ *        https://gitlab.com/nsnam/ns-3-dev/-/issues/224, where a UE try to
+ *        send measurement reports after the RLF, even though all the measurement
+ *        events are properly cancelled upon detecting RLF.
+ *
+ *        The correct behaviour should be that if a UE has already started the
+ *        periodic reporting, and once a new neighbour fulfils the entry
+ *        condition, we just need to add its cell id in cellsTriggeredList,
+ *        without scheduling a new periodic event.
+ *
+ */
+class LteUeMeasurementsPiecewiseTestCase3 : public TestCase
+{
+public:
+  /**
+   * Constructor
+   *
+   * \param name the reference name
+   * \param config LteRrcSap::ReportConfigEutra
+   * \param expectedTime the expected time
+   */
+  LteUeMeasurementsPiecewiseTestCase3 (std::string name,
+                                       LteRrcSap::ReportConfigEutra config,
+                                       std::vector<Time> expectedTime);
+
+  virtual ~LteUeMeasurementsPiecewiseTestCase3 ();
+
+  /**
+   * \brief Triggers when eNodeB receives measurement report from UE, then
+   *        perform verification on it.
+   *
+   * The trigger is set up beforehand by connecting to the
+   * `LteUeRrc::RecvMeasurementReport` trace source.
+   *
+   * Verification consists of checking whether the report carries the right
+   * value of RSRP or not, and whether it occurs at the expected time or not.
+   *
+   * \param context the context
+   * \param imsi the IMSI
+   * \param cellId the cell ID
+   * \param rnti  the RNTI
+   * \param report LteRrcSap::MeasurementReport
+   */
+  void RecvMeasurementReportCallback (std::string context, uint64_t imsi,
+                                      uint16_t cellId, uint16_t rnti,
+                                      LteRrcSap::MeasurementReport report);
+
+private:
+  /**
+   * \brief Setup the simulation with the intended UE measurement reporting
+   *        configuration, run it, and connect the
+   *        `RecvMeasurementReportCallback` function to the
+   *        `LteUeRrc::RecvMeasurementReport` trace source.
+   */
+  virtual void DoRun ();
+
+  /**
+   * \brief Runs at the end of the simulation, verifying that all expected
+   *        measurement reports have been examined.
+   */
+  virtual void DoTeardown ();
+
+
+  /// Teleport the eNb near function
+  void TeleportEnbNear ();
+
+  /**
+   * \brief The active report triggering configuration.
+   */
+  LteRrcSap::ReportConfigEutra m_config;
+
+  /**
+   * \brief The list of expected time when measurement reports are received by
+   *        eNodeB.
+   */
+  std::vector<Time> m_expectedTime;
+
+  /**
+   * \brief Pointer to the element of `m_expectedTime` which is expected to
+   *        occur next in the simulation.
+   */
+  std::vector<Time>::iterator m_itExpectedTime;
+
+  /**
+   * \brief The measurement identity being tested. Measurement reports with
+   *        different measurement identity (e.g. from handover algorithm) will
+   *        be ignored.
+   */
+  uint8_t m_expectedMeasId;
+
+  Ptr<MobilityModel> m_enbMobility; ///< the mobility model
+
+}; // end of class LteUeMeasurementsPiecewiseTestCase3
+
+
 
 
 // ===== LTE-UE-MEASUREMENTS-HANDOVER TEST SUITE =========================== //
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/mesh/helper/mesh-helper.cc ns-3.32/src/mesh/helper/mesh-helper.cc
--- ns-3.31/src/mesh/helper/mesh-helper.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/mesh/helper/mesh-helper.cc	2020-10-06 15:35:43.000000000 -0700
@@ -35,7 +35,7 @@
   m_nInterfaces (1),
   m_spreadChannelPolicy (ZERO_CHANNEL),
   m_stack (0),
-  m_standard (WIFI_PHY_STANDARD_80211a)
+  m_standard (WIFI_STANDARD_80211a)
 {
 }
 MeshHelper::~MeshHelper ()
@@ -193,7 +193,7 @@
   m_ackPolicySelector[ac].Set (n7, v7);
 }
 void 
-MeshHelper::SetStandard (enum WifiPhyStandard standard)
+MeshHelper::SetStandard (enum WifiStandard standard)
 {
   m_standard = standard;
 }
@@ -203,6 +203,13 @@
 {
   Ptr<WifiNetDevice> device = CreateObject<WifiNetDevice> ();
 
+  auto it = wifiStandards.find (m_standard);
+  if (it == wifiStandards.end ())
+    {
+      NS_FATAL_ERROR ("Selected standard is not defined!");
+      return device;
+    }
+
   Ptr<MeshWifiInterfaceMac> mac = m_mac.Create<MeshWifiInterfaceMac> ();
   NS_ASSERT (mac != 0);
   mac->SetSsid (Ssid ());
@@ -212,7 +219,7 @@
   Ptr<WifiPhy> phy = phyHelper.Create (node, device);
   mac->SetAddress (Mac48Address::Allocate ());
   mac->ConfigureStandard (m_standard);
-  phy->ConfigureStandard (m_standard);
+  phy->ConfigureStandardAndBand (it->second.phyStandard, it->second.phyBand);
   device->SetMac (mac);
   device->SetPhy (phy);
   device->SetRemoteStationManager (manager);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/mesh/helper/mesh-helper.h ns-3.32/src/mesh/helper/mesh-helper.h
--- ns-3.31/src/mesh/helper/mesh-helper.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/mesh/helper/mesh-helper.h	2020-10-06 15:35:43.000000000 -0700
@@ -24,7 +24,7 @@
 #define MESH_HELPER_H
 
 #include "ns3/mesh-stack-installer.h"
-#include "ns3/wifi-phy-standard.h"
+#include "ns3/wifi-standards.h"
 #include "ns3/qos-utils.h"
 #include "ns3/object-factory.h"
 
@@ -154,10 +154,10 @@
                                   std::string n6 = "", const AttributeValue &v6 = EmptyAttributeValue (),
                                   std::string n7 = "", const AttributeValue &v7 = EmptyAttributeValue ());
   /**
-   * Set PHY standard
+   * Set standard
    * \param standard the wifi phy standard
    */
-  void SetStandard (enum WifiPhyStandard standard);
+  void SetStandard (enum WifiStandard standard);
   /// \todo SetMeshId 
   //void SetMeshId (std::string s);
   /** 
@@ -265,7 +265,7 @@
   ObjectFactory m_mac; ///< the MAC
   ObjectFactory m_stationManager; ///< the station manager
   ObjectFactory m_ackPolicySelector[4]; ///< ack policy selector for all ACs
-  enum WifiPhyStandard m_standard; ///< phy standard
+  enum WifiStandard m_standard; ///< standard
 
 };
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/mesh/model/dot11s/airtime-metric.cc ns-3.32/src/mesh/model/dot11s/airtime-metric.cc
--- ns-3.31/src/mesh/model/dot11s/airtime-metric.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/mesh/model/dot11s/airtime-metric.cc	2020-10-06 15:35:43.000000000 -0700
@@ -94,8 +94,10 @@
   txVector.SetPreambleType (WIFI_PREAMBLE_LONG);
   //calculate metric
   uint32_t metric = (uint32_t)((double)( /*Overhead + payload*/
-                                 mac->GetPifs () + mac->GetSlot () + mac->GetEifsNoDifs () + //DIFS + SIFS + AckTxTime = PIFS + SLOT + EifsNoDifs
-                                 mac->GetWifiPhy ()->CalculateTxDuration (m_testFrame->GetSize (), txVector, mac->GetWifiPhy ()->GetFrequency())
+                                 //DIFS + SIFS + AckTxTime = 2 * SIFS + 2 * SLOT + AckTxTime
+                                 2 * mac->GetWifiPhy ()->GetSifs () + 2 * mac->GetWifiPhy ()->GetSlot ()
+                                 + mac->GetWifiPhy ()->GetAckTxTime ()
+                                 + mac->GetWifiPhy ()->CalculateTxDuration (m_testFrame->GetSize (), txVector, mac->GetWifiPhy ()->GetPhyBand())
                                  ).GetMicroSeconds () / (10.24 * (1.0 - failAvg)));
   return metric;
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/mesh/model/mesh-wifi-interface-mac.cc ns-3.32/src/mesh/model/mesh-wifi-interface-mac.cc
--- ns-3.31/src/mesh/model/mesh-wifi-interface-mac.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/mesh/model/mesh-wifi-interface-mac.cc	2020-10-06 15:35:43.000000000 -0700
@@ -32,6 +32,7 @@
 #include "ns3/double.h"
 #include "ns3/trace-source-accessor.h"
 #include "ns3/socket.h"
+#include "ns3/wifi-net-device.h"
 
 namespace ns3 {
 
@@ -72,7 +73,7 @@
   return tid;
 }
 MeshWifiInterfaceMac::MeshWifiInterfaceMac ()
-  : m_standard (WIFI_PHY_STANDARD_80211a)
+  : m_standard (WIFI_STANDARD_80211a)
 {
   NS_LOG_FUNCTION (this);
 
@@ -176,17 +177,9 @@
 {
   NS_LOG_FUNCTION (this);
   NS_ASSERT (m_phy != 0); // need PHY to set/get channel
-
-  Ptr<YansWifiPhy> phy = m_phy->GetObject<YansWifiPhy> ();
-  if (phy != 0)
-    {
-      return phy->GetChannelNumber ();
-    }
-  else
-    {
-      return 0;
-    }
+  return m_phy->GetChannelNumber ();
 }
+
 void
 MeshWifiInterfaceMac::SwitchFrequencyChannel (uint16_t new_id)
 {
@@ -203,8 +196,7 @@
    *
    * Now we use dirty channel switch -- just change frequency
    */
-  Ptr<YansWifiPhy> phy = m_phy->GetObject<YansWifiPhy> ();
-  phy->SetChannelNumber (new_id);
+  m_phy->SetChannelNumber (new_id);
   // Don't know NAV on new channel
   m_channelAccessManager->NotifyNavResetNow (Seconds (0));
 }
@@ -314,14 +306,14 @@
   for (uint32_t i = 0; i < m_phy->GetNModes (); i++)
     {
       WifiMode mode = m_phy->GetMode (i);
-      uint16_t gi = ConvertGuardIntervalToNanoSeconds (mode, m_phy->GetShortGuardInterval (), m_phy->GetGuardInterval ());
+      uint16_t gi = ConvertGuardIntervalToNanoSeconds (mode, DynamicCast<WifiNetDevice> (m_phy->GetDevice ()));
       rates.AddSupportedRate (mode.GetDataRate (m_phy->GetChannelWidth (), gi, 1));
     }
   // set the basic rates
   for (uint32_t j = 0; j < m_stationManager->GetNBasicModes (); j++)
     {
       WifiMode mode = m_stationManager->GetBasicMode (j);
-      uint16_t gi = ConvertGuardIntervalToNanoSeconds (mode, m_phy->GetShortGuardInterval (), m_phy->GetGuardInterval ());
+      uint16_t gi = ConvertGuardIntervalToNanoSeconds (mode, DynamicCast<WifiNetDevice> (m_phy->GetDevice ()));
       rates.SetBasicRate (mode.GetDataRate (m_phy->GetChannelWidth (), gi, 1));
     }
   return rates;
@@ -332,7 +324,7 @@
   for (uint32_t i = 0; i < m_stationManager->GetNBasicModes (); i++)
     {
       WifiMode mode = m_stationManager->GetBasicMode (i);
-      uint16_t gi = ConvertGuardIntervalToNanoSeconds (mode, m_phy->GetShortGuardInterval (), m_phy->GetGuardInterval ());
+      uint16_t gi = ConvertGuardIntervalToNanoSeconds (mode, DynamicCast<WifiNetDevice> (m_phy->GetDevice ()));
       if (!rates.IsSupportedRate (mode.GetDataRate (m_phy->GetChannelWidth (), gi, 1)))
         {
           return false;
@@ -442,7 +434,7 @@
           for (uint32_t i = 0; i < m_phy->GetNModes (); i++)
             {
               WifiMode mode = m_phy->GetMode (i);
-              uint16_t gi = ConvertGuardIntervalToNanoSeconds (mode, m_phy->GetShortGuardInterval (), m_phy->GetGuardInterval ());
+              uint16_t gi = ConvertGuardIntervalToNanoSeconds (mode, DynamicCast<WifiNetDevice> (m_phy->GetDevice ()));
               uint64_t rate = mode.GetDataRate (m_phy->GetChannelWidth (), gi, 1);
               if (rates.IsSupportedRate (rate))
                 {
@@ -548,9 +540,9 @@
 }
 
 void
-MeshWifiInterfaceMac::FinishConfigureStandard (enum WifiPhyStandard standard)
+MeshWifiInterfaceMac::ConfigureStandard (enum WifiStandard standard)
 {
-  RegularWifiMac::FinishConfigureStandard (standard);
+  RegularWifiMac::ConfigureStandard (standard);
   m_standard = standard;
 
   // We use the single DCF provided by WifiMac for the purpose of
@@ -560,10 +552,5 @@
   m_txop->SetMaxCw (0);
   m_txop->SetAifsn (1);
 }
-WifiPhyStandard
-MeshWifiInterfaceMac::GetPhyStandard () const
-{
-  return m_standard;
-}
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/mesh/model/mesh-wifi-interface-mac.h ns-3.32/src/mesh/model/mesh-wifi-interface-mac.h
--- ns-3.31/src/mesh/model/mesh-wifi-interface-mac.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/mesh/model/mesh-wifi-interface-mac.h	2020-10-06 15:35:43.000000000 -0700
@@ -156,17 +156,11 @@
    */
   void SetBeaconGeneration (bool enable);
   /**
-   * Get phy standard in use
+   * Finish configuration based on the WifiStandard being provided
    *
-   * \returns the wifi phy standard
+   * \param standard the WifiStandard being configured
    */
-  WifiPhyStandard GetPhyStandard () const;
-  /**
-   * Finish configuration based on the WifiPhyStandard being provided
-   *
-   * \param standard the WifiPhyStandard being configured
-   */
-  virtual void FinishConfigureStandard (enum WifiPhyStandard standard);
+  virtual void ConfigureStandard (enum WifiStandard standard);
   /**
    * Assign a fixed random variable stream number to the random variables
    * used by this model.  Return the number of streams (possibly zero) that
@@ -248,8 +242,8 @@
   };
   Statistics m_stats; ///< statistics
 
-  /// Current PHY standard: needed to configure metric
-  WifiPhyStandard m_standard;
+  /// Current standard: needed to configure metric
+  WifiStandard m_standard;
 
   /// Add randomness to beacon generation
   Ptr<UniformRandomVariable> m_coefficient;
